
//	Copyright 2010 PaletteSoft LLC

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	003 2010.??.??
//	E
// ---------------------------------------------------------------------------
//	002 2010.11.16		 2010.01.16 tkoba
//	Esw[qo͐ݒ肩͐ݒ֕ύX
// ---------------------------------------------------------------------------
//	001 2010.07.29
//	EVK쐬
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************
// ***************************************************************************

	//	*****  *****


	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾
#include	"version.h"													//	o[Wԍ̒`

	//	*****  *****

#include	"device.h"													//	foCX

// ***************************************************************************
// *	zdl															 *
// ***************************************************************************
/*
	CZT]TvvO		PIC16F648A	CLOCK:INTRCIO/4MHz
	ӁFdd͂RDRu				Sensirion SHT11 library test

	PORT	FUNC		@\						l
	--------------------------------------------------------------------------
	RA0:	PR_T1		ff[q				o	ʕϊixj
	RA1:	PR_T0		ff[q				o	xV[PX
	RA2:	PR_S0		ff[q				o	Xe[^XWX^ANZX
	RA3:	-----		gp					o	igpj
	RA4:	-----		gp					o	
	RA5:	SELECT		\؂ւ				kō\		VCC/GND؂ւ
	RA6:	PR_H1		ff[q				o	ʕϊixj
	RA7:	PR_H0		ff[q				o	xV[PX

	RB0:	-----		gp					o
	RB1:	MRXD		j^M					i\j			OvAbvPOj
	RB2:	MTXD		j^M					ʐM											 2010.01.16 tkoba
	RB3:	-----		gp					o
	RB4:	SHT_SCK		rgsNbN			o	NbN
	RB5:	SHT_DATA	rgsf[^			o	of[^		OvAbvPOj
	RB6:	-----		gp					o
	RB7:	-----		gp					o

	E\؂ւMdɓǂݏoA蕪\Œœ삷B
	ExAx擾Ǎoߏ󋵂ʐMŏo͂B
	E̓ZTBA芮Pbҋ@B
	Egp|[g͏o͂kƂA[q̓I[vƂB

	Eff[q̔zu@c@ʏ펞kAƎg

		 18:RA1 xV[PX				PR_T0
	       17:RA0 ʕϊixj				PR_T1
	      			
	      @ 16:RA7 xV[PX				PR_H0
	           15:RA6 ʕϊixj				PR_H1
	          	
	
	  18  17  16  15
	
	   1   2   3   4
	
	      			
	        2:RA3 igpj
	      1:RA2 Xe[^XWX^ANZX		PR_S0
*/

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	UNPROTECT													//	vÕveNg֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	LVPDIS														//	d݋֎~RB4/PGMRB4ŗp
		&	BORDIS														//	uEAEgo֎~
		&	MCLRDIS														//	RA5/_MCLR[qRA5ŗp
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNœ삵RA6RA7͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

/*
	ʐM[hɂ钲ʐMi񓯊jł̒ʐMx͈ȉ̎ŎZoB
	bps = Fosc / (16 * (X + 1))
	16 * (X + 1) = Fosc / bps
	X + 1 = (Fosc / bps) / 16 = Fosc / (bps * 16)
	X = (Fosc / (bps * 16)) - 1

	iPjPXQOȌꍇ
		bps = 19200, X=12.02083 = 12
		Fosc / (16 * (12 + 1)) = 19230.7692bps -> +0.160%
		19230bps ->  520us/byte									50char = 26ms	̃^CAEgԂlƁuvI

	iQjXUOȌꍇ
		bps =  9600, X=25.04167 = 25
		Fosc / (16 * (25 + 1)) =  9615.3846bps -> +0.160%		50char = 52ms
		 9615bps -> 1040us/byte
*/

#if 1																	//	PFPXQOOAOFXUOO
#define	UART_SPEED				12										//	PXQOOڕW
#else
#define	UART_SPEED				25										//	@XUOOڕW
#endif

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************

	//	***** |[g` *****

typedef	union {
	UB		BYTE;
	struct {
		_UINT	PR_T1		: 1;										//	ff[q			o	ʏk	ʕϊixj
		_UINT	PR_T0		: 1;										//	ff[q			o	ʏk	xV[PX
		_UINT	PR_S0		: 1;										//	ff[q			o	ʏk	Xe[^XWX^ANZX
		_UINT	_dummy3		: 1;										//	ff[q			o	k		igpj
		_UINT	_dummy4		: 1;										//	gp				o	k
		_UINT	SELECT		: 1;										//	\؂ւ			|
		_UINT	PR_H1		: 1;										//	ff[q			o	ʏk	ʕϊixj
		_UINT	PR_H0		: 1;										//	ff[q			o	ʏk	xV[PX
	} BIT;
} uPortA;

#define	SIG_SELECT				(UB)(BIT05)								//	\؂ւ

//								  76543210
#define	DEV_INIT_A_DIR			0b00100000								//	o͕
#define	DEV_INIT_A_DATA			0b00000000								//	f[^

	//	***** |[ga *****											//	}NŊOɐ錾zu

typedef	union {
	UB		BYTE;
	struct {
		_UINT	_dummy0		: 1;										//	gp				o	k
		_UINT	MRXD		: 1;										//	j^M				|
		_UINT	MTXD		: 1;										//	j^M				g@@g厖	 2010.01.16 tkoba
		_UINT	_dummy3		: 1;										//	gp				o	k
		_UINT	SHTCK		: 1;										//	rgsNbN		o	k
		_UINT	SHTDT		: 1;										//	rgsf[^			k@@k厖AǌʓIɂgԂ
		_UINT	_dummy6		: 1;										//	gp				o	k
		_UINT	_dummy7		: 1;										//	gp				o	k
	} BIT;
} uPortB;

#define	SHT_DATA				(UB)(BIT05)								//	rgsf[^̏

//								  76543210
#define	DEV_INIT_B_DIR			0b00100110								//	o͕@c@rgsf[^͓́Ao͂k̐؂ւŐ䂷	 2010.01.16 tkoba
#define	DEV_INIT_B_DATA			0b00000100								//	f[^

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************
// ***************************************************************************

	//	***** ʕϐ *****

uPortA	vDevPortA;														//	|[g`̃obNAbvif[^j@}Nꍇ͊O錾Ώ

uPortB	vDevPortB;														//	|[gãobNAbvif[^j@}Nꍇ͊O錾Ώ
uPortB	vDevDirB;														//	|[gãobNAbvi@j

// ***************************************************************************
// ***************************************************************************
// *	e[u															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	{															 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		{
//
//	
//	
void	DevStd______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CRݒ肵܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** ͂߂ *****

	di();																//	CIɊ荞݋֎~

	//	***** { *****

//				  76543210
	OPTION =	0b11011111;												//	IvVWX^
																		//	b0:PS0		1	vcs͂PQW						gp
																		//	b1:PS1		1	ij								gp
																		//	b2:PS2		1	ij								gp
																		//	b3:PSA		1	vXP[͂vcsŗp				gp
																		//	b4:T0SE		1	NbN͗GbWŃJEg		gp
																		//	b5:T0CS		0	slqO͓NbNœ			@q`S
																		//	b6:INTEDG	1	O荞݂͗オGbWŋN	@l
																		//	b7:_RBPU	1	|[gãvAbv͍sȂ			@l
	//	***** o̓|[g *****

//				  76543210
	CMCON =		0b00000111;												//	Rp[^o͍\WX^iRp[^Itɂ|[gėpój

	vDevPortA.BYTE = DEV_INIT_A_DATA;									//	|[g`f[^̃obNAbv
	PORTA = vDevPortA.BYTE;												//	|[g`f[^Zbg
	TRISA = DEV_INIT_A_DIR;												//	|[g`o͕

	vDevPortB.BYTE = DEV_INIT_B_DATA;									//	|[gaf[^̃obNAbv
	PORTB = vDevPortB.BYTE;												//	|[gaf[^Zbg

	vDevDirB.BYTE = DEV_INIT_B_DIR;										//	|[gaõ͕obNAbv
	TRISB = vDevDirB.BYTE;												//	|[gao͕

	//	***** ܂ *****

	;																	//	ɂȂ
}

//	
//	
//
// 		M
//
//	
//	
void	DevSig______(void) {}											//	op֐

//============================================================================
//	xZTւ̏o
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	xZTւ̐M𐧌䂵܂B
//============================================================================
void	DevSigPutShtCk_H(void)	{	vDevPortB.BIT.SHTCK = 1;	PORTB = vDevPortB.BYTE;	}
void	DevSigPutShtCk_L(void)	{	vDevPortB.BIT.SHTCK = 0;	PORTB = vDevPortB.BYTE;	}

void	DevSigPutShtDt_H(void)	{	vDevDirB.BIT.SHTDT  = 1;	TRISB = vDevDirB.BYTE;	}
void	DevSigPutShtDt_L(void)	{	vDevDirB.BIT.SHTDT  = 0;	TRISB = vDevDirB.BYTE;	}

//============================================================================
//	xZT̓
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	xZTM͂܂B
//============================================================================
UB		DevSigGetShtDt(void)	{	return(PORTB & SHT_DATA);	}

//============================================================================
//	ZN^̏Ԏ擾
//----------------------------------------------------------------------------
//	́F	
//	óF	ZN^̏ԁiOF\AOFᕪ\j
//----------------------------------------------------------------------------
//	lF	ZN^̏ԂԂ܂B
//============================================================================
UB		DevSigGetSw(void)
{
	return(PORTA & SIG_SELECT);											//	M}XNĕԂ܂
}

//============================================================================
//	ffpM̐
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ԂɉĐ䂷ffpM𐧌䂵܂B
//============================================================================
void	DevSigPR_T0_H(void)		{	vDevPortA.BIT.PR_T0 = 1;	PORTA = vDevPortA.BYTE;	}	//	xV[PX
void	DevSigPR_T0_L(void)		{	vDevPortA.BIT.PR_T0 = 0;	PORTA = vDevPortA.BYTE;	}
void	DevSigPR_T1_H(void)		{	vDevPortA.BIT.PR_T1 = 1;	PORTA = vDevPortA.BYTE;	}	//	ʕϊixj
void	DevSigPR_T1_L(void)		{	vDevPortA.BIT.PR_T1 = 0;	PORTA = vDevPortA.BYTE;	}

void	DevSigPR_H0_H(void)		{	vDevPortA.BIT.PR_H0 = 1;	PORTA = vDevPortA.BYTE;	}	//	xV[PX
void	DevSigPR_H0_L(void)		{	vDevPortA.BIT.PR_H0 = 0;	PORTA = vDevPortA.BYTE;	}
void	DevSigPR_H1_H(void)		{	vDevPortA.BIT.PR_H1 = 1;	PORTA = vDevPortA.BYTE;	}	//	ʕϊixj
void	DevSigPR_H1_L(void)		{	vDevPortA.BIT.PR_H1 = 0;	PORTA = vDevPortA.BYTE;	}

void	DevSigPR_S0_H(void)		{	vDevPortA.BIT.PR_S0 = 1;	PORTA = vDevPortA.BYTE;	}	//	Xe[^XWX^ANZX
void	DevSigPR_S0_L(void)		{	vDevPortA.BIT.PR_S0 = 0;	PORTA = vDevPortA.BYTE;	}

//	
//	
//
// 		ʐM
//
//	
//	
void	DevCom______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʐMݒ肵܂B
//			ėpo̓|[g͒ʐMCɐ؂ւ܂
//			ʐM͈ȉ̒ʂłB
//			E		FUARTi񓯊j
//			EʐMx		F19200bpsigp錹Uɂ덷̍lKvj
//			Ef[^		F8bits
//			EpeB		FNone
//			EXgbvrbgF1bit
//			Ȇ		FM̂ݗpAM͒~ԂƂiȂj
//			E荞		FMobt@ɂ銄荞݂͗p܂
//============================================================================
void	DevComInit(void)
{
	_UB		Dummy;														//	_~[[hpf[^

	//	***** {ݒ *****

//				  76543210
	TXSTA =		0b00000010;												//	MXe[^XARg[WX^
																		//	b0:TX9D		0	M̂XrbgڏipeBƂėp\j
																		//	b1:TRMT		1	ǂݎpFVtgWX^󂫏󋵂ʒm
																		//	b2:BRGH		0	ᑬʐM[hiʐMxݒ莞ɗpj
																		//	b3:-----	0	
																		//	b4:SYNC		0	i񓯊jʐM[hiʐMł͖j
																		//	b5:TXEN		0	M~
																		//	b6:TX9		0	WrbgM[h
																		//	b7:CSRC		0	X[u[hiʐMł͖Ӗj

//				  76543210
	RCSTA =		0b10000000;												//	MXe[^XARg[WX^
																		//	b0:RX9D		0	ǂݎpFM̂XrbgڏipeBƂėp\j
																		//	b1:OERR		0	ǂݎpFI[o[G[ʒm
																		//	b2:FERR		0	ǂݎpFt[~OG[ʒm
																		//	b3:ADEN		0	AhXoiXrbgڂ̓peBƂėp\j
																		//	b4:CREN		0	AM֎~iʐMł̈Ӗj
																		//	b5:SREN		0	PM֎~iʐMł͖Ӗj
																		//	b6:RX9		0	WrbgM[h
																		//	b7:SPEN		1	VA|[gLiqaPAqaQ͂qwcAswcƂėpj

	//	***** ʐMxݒ *****

	BRGH = 1;															//	ʐM[h
	SPBRG = UART_SPEED;													//	ʐMxݒ

	//	***** 荞ݐݒ *****

//*	RCIF = 0;															//	M荞ݗv			@ǂݏopȂ̂Őݒsv
//*	TXIF = 0;															//	Mobt@󊄂荞ݗv	@ǂݏopȂ̂Őݒsv

	RCIE = 0;															//	M荞݋֎~
	TXIE = 0;															//	Mobt@󊄂荞݋֎~

	//	***** ʐMJn *****

	Dummy = RCREG;														//	Mobt@̃_~[[h			@V~[^Ń[jOłi

	TXEN = 1;															//	M							@łswhePɂȂ
	CREN = 1;															//	AM
}

//============================================================================
//	
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʐM܂B
//			ʐMC͔ėpo̓|[gɐ؂ւ܂B
//
//			MVtgWX^̋󂫂҂ĂƂs܂B̂ɁAőłP
//			oCgʐMԂ̑ҋ@܂B
//
//			MVtgWX^̏󋵂sqls̋Ɏ኱̃^C
//			O܂BMJnÔPrbgԒxB
//			mɑM̂ł΁APrbgԑҋ@Ăsqls
//			mFBsqlsőMmFĂXɂPrbgԑҋ@Kv
//			܂B
//			ȂA^pʂŖł̂łΑ΍͕svłB
//
//			ʐM̃W[̏d͂킸łȂ΁A{֐Ăяo
//			AƂƂƐQĂ܂BďsvcBŋB
//============================================================================
void	DevComExit(void)
{
	//	***** Mҋ@ *****

	DevTimWaitMs(1);													//	ȂƂŒł݂ȂP҂ƂB

	while (TRMT == 0) {													//	MiMVtgWX^gpjȂ珄
		;																//	ҋ@܂
	}

	//	***** VA|[g̓~ *****							//	@ėpo̓|[gƂĂ̏Ԃɒ

	SPEN = 0;															//	VA|[giqaPAqaQ͔ėpo̓|[gƂėpj
}

//============================================================================
//	obt@̑M
//----------------------------------------------------------------------------
//	́F	obt@AhX
//	óF	
//----------------------------------------------------------------------------
//	lF	obt@Ɋi[镶R[h𑗐M܂B
//============================================================================
void	DevComSendData(const UB *Buffer)
{
	UB		Data;														//	Mf[^

	while (1) {															//	obt@𑍂đM

		if ((Data = *Buffer) == CODE_NUL) {								//	obt@ǂݏo當I[oH
			break;														//	Eo
		}
		Buffer ++;														//	obt@AhXXV

		while (TXIF == 0) {												//	Mobt@iswqdfj܂őҋ@
			;															//	őPoCgʐMԂҋ@
		}

		TXREG = Data;													//	Mf[^ZbgiWrbg[hȂ̂ŃpeB͕svj
	}
}

//	
//	
//
// 		Ԑ
//
//	
//	
void	DevTim______(void) {}											//	op֐

//============================================================================
//	~bPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiO`QTTj
//	óF	
//----------------------------------------------------------------------------
//	lF	\tgEFA^C}𗘗pҋ@s܂B
//============================================================================
void	DevTimWaitMs(UB Time)
{
	while (Time --) {													//	ҋ@Ԃ菄
		__delay_ms(1);													//	Pҋ@
	}
}

//============================================================================
//	bPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiO`QTTj
//	óF	
//----------------------------------------------------------------------------
//	lF	\tgEFA^C}𗘗pҋ@s܂B
//============================================================================
void	DevTimWaitSec(UB Time)
{
	while (Time --) {													//	ҋ@Ԃ菄
		DevTimWaitMs(250);												//	QTOҋ@
		DevTimWaitMs(250);												//	QTOҋ@
		DevTimWaitMs(250);												//	QTOҋ@
		DevTimWaitMs(250);												//	QTOҋ@
	}
}

//	
//	
//
// 		ꃉCu
//
//	
//	
void	DevLib______(void) {}											//	op֐

//============================================================================
//	SoCg揜
//----------------------------------------------------------------------------
//	́F	ƃAhXiRj
//	óF	
//----------------------------------------------------------------------------
//	lF	SoCgwR̍ƃAhXɂ揜s܂B
//============================================================================
void	DevLibAddUW(UW *ValueA, const UW *ValueB, const UW *ValueC)		{	*ValueA = *ValueB + *ValueC;	}
void	DevLibSubUW(UW *ValueA, const UW *ValueB, const UW *ValueC)		{	*ValueA = *ValueB - *ValueC;	}
void	DevLibMulUW(UW *ValueA, const UW *ValueB, const UW *ValueC)		{	*ValueA = *ValueB * *ValueC;	}
void	DevLibDivUW(UW *ValueA, const UW *ValueB, const UW *ValueC)		{	*ValueA = *ValueB / *ValueC;	}

//============================================================================
//	oCgrbg̋tzu
//----------------------------------------------------------------------------
//	́F	oCgf[^
//	óF	tzuꂽoCgf[^
//----------------------------------------------------------------------------
//	lF	oCgf[^̃rbg̕тt]܂B
//
//			悤͐FX̂łAԍȂ̂̓AZuł傤H
//			oVtgJԂ΍őłBłt@CWX^Ao
//			NlcƖʓ|łB
//			\̓}CRȂSrbgÂzœւłǂˁB
//			ohb}CR͔zANZXeʂ򂤂̂ orz
//			łW񔻒ɂĂ݂܂BAւ͗eՂłB
//============================================================================
UB		DevLibBitRev(UB Value)
{
	UB		Result = 0x00;												//	ƏNA

	if (Value & (UB)BIT00)	Result |= (UB)BIT07;						//	0 -> 7
	if (Value & (UB)BIT01)	Result |= (UB)BIT06;						//	1 -> 6
	if (Value & (UB)BIT02)	Result |= (UB)BIT05;						//	2 -> 5
	if (Value & (UB)BIT03)	Result |= (UB)BIT04;						//	3 -> 4
	if (Value & (UB)BIT04)	Result |= (UB)BIT03;						//	4 -> 3
	if (Value & (UB)BIT05)	Result |= (UB)BIT02;						//	5 -> 2
	if (Value & (UB)BIT06)	Result |= (UB)BIT01;						//	6 -> 1
	if (Value & (UB)BIT07)	Result |= (UB)BIT00;						//	7 -> 0

	return(Result);														//	ʂԂ܂
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

